<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2010 Frank Frewer (info@frankfrewer.de)
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
	// DEFAULT initialization of a module [BEGIN]
unset($MCONF);
require ("conf.php");
require ($BACK_PATH."init.php");
require ($BACK_PATH."template.php");
$LANG->includeLLFile("EXT:fr_pwsdownload/mod1/locallang.php");
#include ("locallang.php");
require_once (PATH_t3lib."class.t3lib_scbase.php");
$BE_USER->modAccess($MCONF,1);	// This checks permissions and exits if the users has no permission for entry.
	// DEFAULT initialization of a module [END]

/**
 * Module 'Password Secured Downloads - Administration' for the 'fr_pwsdownload' extension.
 *
 * @author	Frank Frewer <info@frankfrewer.de>
 */
class tx_frpwsdownload_module1 extends t3lib_SCbase {
	var $pageinfo;
	var $action;
	var $pagelist = '';


	/**
	 * Initialization of the module
	 *
	 * @return	void
	 */
	function init()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

		parent::init();

		$this->action = (t3lib_div::GPvar("action") != "" ? t3lib_div::GPvar("action") : "start");
		mt_srand((double)microtime()*1000000);

		/*
		if (t3lib_div::_GP("clear_all_cache"))	{
			$this->include_once[]=PATH_t3lib."class.t3lib_tcemain.php";
		}
		*/
	}

	/**
	 * Adds items to the ->MOD_MENU array. Used for the function menu selector.
	 *
	 * @return	void
	 */
	function menuConfig()	{
		global $LANG;
		$this->MOD_MENU = Array (
			"function" => Array (
				"1" => $LANG->getLL("function1"),
				"2" => $LANG->getLL("function2"),
				"3" => $LANG->getLL("function3"),
			)
		);
		parent::menuConfig();
	}

		// If you chose "web" as main module, you will need to consider the $this->id parameter which will contain the uid-number of the page clicked in the page tree
	/**
	 * Main function of the module. Write the content to $this->content
	 *
	 * @return	void
	 */
	function main()	{
		global $BE_USER,$LANG,$BACK_PATH,$TCA_DESCR,$TCA,$CLIENT,$TYPO3_CONF_VARS;

		// Access check!
		// The page will show only if there is a valid page and if this page may be viewed by the user
		$this->pageinfo = t3lib_BEfunc::readPageAccess($this->id,$this->perms_clause);
		$access = is_array($this->pageinfo) ? 1 : 0;

		if (($this->id && $access) || ($BE_USER->user["admin"] && !$this->id))	{

			if ($this->action == "send_codes") {
				$this->download();
			}
			else {
					// Draw the header.
				$this->doc = t3lib_div::makeInstance("mediumDoc");
				$this->doc->backPath = $BACK_PATH;
				//$this->doc->form='<form action="" method="POST">';

				// initialize table
				$this->doc->inDocStylesArray['tables'] = $this->getTableCSS();

				// Add css: Use the the available space in the backend
				$this->doc->inDocStyles = 'div.typo3-mediumDoc { width:90%; }';

					// JavaScript
				$this->doc->JScode = '
				<script language="javascript" type="text/javascript">
						script_ended = 0;
						function jumpToUrl(URL)	{
							document.location = URL;
						}
					</script>
				';
				$this->doc->postCode='
					<script language="javascript" type="text/javascript">
						script_ended = 1;
						if (top.fsMod) top.fsMod.recentIds["web"] = '.intval($this->id).';
					</script>
				';

				$headerSection = $this->doc->getHeader("pages",$this->pageinfo,$this->pageinfo["_thePath"])."<br>".$LANG->sL("LLL:EXT:lang/locallang_core.php:labels.path").": ".t3lib_div::fixed_lgd_pre($this->pageinfo["_thePath"],50);

				$this->content.=$this->doc->startPage($LANG->getLL("title"));
				$this->content.=$this->doc->header($LANG->getLL("title"));
				$this->content.=$this->doc->spacer(5);
				$this->content.=$this->doc->section("",$this->doc->funcMenu($headerSection,t3lib_BEfunc::getFuncMenu($this->id,"SET[function]",$this->MOD_SETTINGS["function"],$this->MOD_MENU["function"])));
				$this->content.=$this->doc->divider(5);


				// Render content:
				$this->moduleContent();


				// ShortCut
				if ($BE_USER->mayMakeShortcut())	{
					$this->content.=$this->doc->spacer(20).$this->doc->section("",$this->doc->makeShortcutIcon("id",implode(",",array_keys($this->MOD_MENU)),$this->MCONF["name"]));
				}

				$this->content.=$this->doc->spacer(10);
			}
		} else {
				// If no access or if ID == zero

			$this->doc = t3lib_div::makeInstance("mediumDoc");
			$this->doc->backPath = $BACK_PATH;

			$this->content.=$this->doc->startPage($LANG->getLL("title"));
			$this->content.=$this->doc->header($LANG->getLL("title"));
			$this->content.=$this->doc->spacer(5);
			$this->content.=$this->doc->spacer(10);
		}
	}

	/**
	 * Prints out the module HTML
	 *
	 * @return	void
	 */
	function printContent()	{

		$this->content.=$this->doc->endPage();
		echo $this->content;
	}


	/**
	 * Generates the module content
	 *
	 * @return	void
	 */
	function moduleContent()	{
		global $LANG;
		$db =& $GLOBALS['TYPO3_DB'];

		// get the subpages list
		if ($this->id) {
			$this->pagelist = strval($this->id);
			$this->getSubPages($this->id, $this->pagelist);
		} else {
			$this->content.= $LANG->getLL("no_page_selected");
			return;
		}

		switch((string)$this->MOD_SETTINGS["function"])	{
			// show download statistic by user
			case 1:


				$stat_query = $db->exec_SELECTquery('element_uid, element_pid, element_title, element_document, element_mtime, element_user, COUNT(*) as count', 'tx_frpwsdownload_statdata', 'tx_frpwsdownload_statdata.element_pid IN ('.$this->pagelist.')','element_user, element_uid','count desc, element_user',1000);
					$content = "<hr /><br />" . $LANG->getLL("downloads_by_user") . "<br /><br />";
				// render table
				$content .= '<table class="fr-pwsdownload-table" summary="'.$LANG->getLL("Msg1").'">';
				$content .= '<caption>'.$LANG->getLL("Msg1").'</caption>';
				$content .= '<thead><tr>';
				$content .= '<td>' . $LANG->getLL("user") . "</td>";
				$content .= '<td>' . $LANG->getLL("uid") . "</td>";
				$content .= '<td>' . $LANG->getLL("pid") . "</td>";
				$content .= '<td>' . $LANG->getLL("title") . "</td>";
				$content .= '<td>' . $LANG->getLL("document") . "</td>";
				$content .= '<td>' . $LANG->getLL("file_mtime") . "</td>";
				$content .= '<td>' . $LANG->getLL("downloads") . "</td>";
				$content .= '</tr></thead><tbody>';
				for ($i=1; $stat = $db->sql_fetch_assoc($stat_query); $i++) {
					$content .= '<tr>';
					$content .= sprintf("<td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td>", $stat['element_user'], $stat['element_uid'], $stat['element_pid'], $stat['element_title'], $stat['element_document'], $stat['element_mtime'], $stat['count']);
					$content .= '</tr>';
				}
				$content .= '</tbody>';
				// render an empty footer row
				$content .= '<tfoot>';
				$content .= '<tr>';
				$footerColumns = 7;
				for ($column_number=0; $column_number<$footerColumns; $column_number++) {
					$content .= '<td>&nbsp;</td>';
				}
				$content .= '</tr>';
				$content .= '</tfoot>';
				$content .= '</table>';
				$this->content.=$this->doc->section($LANG->getLL("Msg1"),$content,0,1);

			break;

			// show download statistic by elements
			case 2:
				$stat_query = $db->exec_SELECTquery('element_uid, element_pid, element_title, element_document, element_mtime, COUNT(*) as count', 'tx_frpwsdownload_statdata', 'tx_frpwsdownload_statdata.element_pid IN ('.$this->pagelist.')','element_uid','count desc',1000);
				$content .= "<hr /><br />" . $LANG->getLL("downloads_by_element") . "<br /><br />";
				$content .= '<table class="fr-pwsdownload-table" summary="'.$LANG->getLL("Msg2").'">';
				$content .= '<caption>'.$LANG->getLL("Msg2").'</caption>';
				$content .= '<thead><tr>';
				$content .= '<td>' . $LANG->getLL("uid") . "</td>";
				$content .= '<td>' . $LANG->getLL("pid") . "</td>";
				$content .= '<td>' . $LANG->getLL("title") . "</td>";
				$content .= '<td>' . $LANG->getLL("document") . "</td>";
				$content .= '<td>' . $LANG->getLL("file_mtime") . "</td>";
				$content .= '<td>' . $LANG->getLL("downloads") . "</td>";
				$content .= '</tr></thead><tbody>';
				for ($i=1; $stat = $db->sql_fetch_assoc($stat_query); $i++) {
					$download_date = $stat['year']."-".$stat['month']."-".$stat['day'];
					$content .= '<tr>';
					$content .= sprintf("<td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td>", $stat['element_uid'], $stat['element_pid'], $stat['element_title'], $stat['element_document'], $stat['element_mtime'], $stat['count']);
					$content .= '</tr>';
				}
				$content .= '</tbody>';
				// render an empty footer row
				$content .= '<tfoot>';
				$content .= '<tr>';
				$footerColumns = 6;
				for ($column_number=0; $column_number<$footerColumns; $column_number++) {
					$content .= '<td>&nbsp;</td>';
				}
				$content .= '</tr>';
				$content .= '</tfoot>';
				$content .= '</table>';
				$this->content.=$this->doc->section($LANG->getLL("Msg2"),$content,0,1);

			break;

			// show statistic
			case 3:
				$stat_query = $db->exec_SELECTquery('*', 'tx_frpwsdownload_statdata', 'tx_frpwsdownload_statdata.element_pid IN ('.$this->pagelist.')','tstamp DESC','',1000);
				$content .= "<hr /><br />" . $LANG->getLL("all_downloads") . "<br /><br />";
				$content .= '<table class="fr-pwsdownload-table" summary="'.$LANG->getLL("Msg3").'">';
				$content .= '<caption>'.$LANG->getLL("Msg3").'</caption>';
				$content .= '<thead><tr>';
				$content .= '<td>' . $LANG->getLL("date_of_download") . "</td>";
				$content .= '<td>' . $LANG->getLL("uid") . "</td>";
				$content .= '<td>' . $LANG->getLL("pid") . "</td>";
				$content .= '<td>' . $LANG->getLL("title") . "</td>";
				$content .= '<td>' . $LANG->getLL("document") . "</td>";
				$content .= '<td>' . $LANG->getLL("file_mtime") . "</td>";
				$content .= '<td>' . $LANG->getLL("user") . "</td>";
				$content .= '</tr></thead><tbody>';
				for ($i=1; $stat = $db->sql_fetch_assoc($stat_query); $i++) {
					$download_date = $stat['year']."-".$stat['month']."-".$stat['day'];
					$content .= '<tr>';
					$content .= sprintf("<td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td>", $download_date, $stat['element_uid'], $stat['element_pid'], $stat['element_title'], $stat['element_document'], $stat['element_mtime'], $stat['element_user']);
					$content .= '</tr>';
				}
				$content .= '</tbody>';
				// render an empty footer row
				$content .= '<tfoot>';
				$content .= '<tr>';
				$footerColumns = 7;
				for ($column_number=0; $column_number<$footerColumns; $column_number++) {
					$content .= '<td>&nbsp;</td>';
				}
				$content .= '</tr>';
				$content .= '</tfoot>';
				$content .= '</table>';
				$this->content.=$this->doc->section($LANG->getLL("Msg3"),$content,0,1);

			break;

		}
	}

	/**
	 * getSubPages (from ke_stats)
	 *
	 * returns commalist of all subpages of a given page
	 * works recursive
	 * Does explicitly not check for hidden pages and restricted access!
	 *
	 * @param	integer		$page_uid
	 * @return	void
	 * @access public
	 */
	function getSubPages($page_uid=0) {
		if ($page_uid) {
			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid', 'pages', 'pid='.intval($page_uid));
			while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res))	{
				if (strlen($this->pagelist)>0) {
					$this->pagelist .= ',';
				}
				$this->pagelist .= $row['uid'];
				$this->getSubPages($row['uid']);
			}
		} else {
			$this->pagelist = '';
		}
	}

	/**
	 * returns the css for the result tables
	 *
	 * @return	string
	 */
	function getTableCSS() {
		return '

.buttonlink {
	float:left;
	margin: .5em 3px 0 0;
	font-size: 10px;
	font-weight: bold;
	border: 1px solid gray;
	display:block;
	padding:2px;
}

.update_information {
	font-style: italic;
	text-align: right;
	font-size:9px;
}

table.fr-pwsdownload-table {
	color: #7F7F7F;
	font-size: 10px;
	border-collapse: collapse;
	text-align:left;
	clear:left;
}

table.fr-pwsdownload-table,
table.fr-pwsdownload-table caption {
	width:100%;
	border-right: 1px solid #CCC;
	border-left: 1px solid #CCC
}

table.fr-pwsdownload-table caption {
	margin-top: 15px;
}

table.fr-pwsdownload-table caption,
table.fr-pwsdownload-table th,
table.fr-pwsdownload-table td {
	border-left: 0;
	padding: 2px
}

table.fr-pwsdownload-table caption,
table.fr-pwsdownload-table thead th,
table.fr-pwsdownload-table tfoot th,
table.fr-pwsdownload-table tfoot td {
	background-color: #B7B7CC;
	color: #FFF;
	font-weight: bold;
	text-transform: uppercase;
}

table.fr-pwsdownload-table thead td,
table.fr-pwsdownload-table thead th {
	background-color: #E2E2E9;
}

table.fr-pwsdownload-table tbody td,
table.fr-pwsdownload-table tbody th {
	padding: 4px 2px;
    white-space: nowrap;
    border-right: 1px solid #CCC;
}

table.fr-pwsdownload-table tbody tr.odd {
	background-color: #F7F7F7;
	color: #666;
}

table.fr-pwsdownload-table tbody a {
	padding: 1px 2px;
	text-decoration: none;
	border-bottom: 1px dotted #ccc;
}


table.fr-pwsdownload-table tbody a:link,
table.fr-pwsdownload-table tbody a:visited,
table.fr-pwsdownload-table tbody a:hover,
table.fr-pwsdownload-table tbody a:focus,
table.fr-pwsdownload-table tbody a:focus {
	color:black;
	border-bottom: 1px dotted #333333;
}

h3 {
	padding-left:0px;
}

table.fr-pwsdownload-table tbody tr:hover {
	background-color: #EEE;
}


table.fr-pwsdownload-table tbody a:visited:after {
	/*content: "\00A0\221A"*/
}
		';
	}

}



if (defined("TYPO3_MODE") && $TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/fr_pwsdownload/mod1/index.php"])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]["XCLASS"]["ext/fr_pwsdownload/mod1/index.php"]);
}




// Make instance:
$SOBE = t3lib_div::makeInstance("tx_frpwsdownload_module1");
$SOBE->init();

// Include files?
foreach($SOBE->include_once as $INC_FILE)	include_once($INC_FILE);

$SOBE->main();
$SOBE->printContent();

?>
